diff --git a/module/zfs/vdev_raidz.c b/module/zfs/vdev_raidz.c
index 4cd21df8938..9e5464535f4 100644
--- a/module/zfs/vdev_raidz.c
+++ b/module/zfs/vdev_raidz.c
@@ -1577,6 +1577,13 @@ vdev_raidz_io_start(zio_t *zio)
 	raidz_col_t *rc;
 	int c, i;
 
+	/*
+	 * Optional I/Os that return to us have served their purpose for
+	 * improving aggregation continuity and can be ignored.
+	 */
+	if (zio->io_type == ZIO_TYPE_WRITE && zio->io_flags & ZIO_FLAG_NODATA)
+		return (ZIO_PIPELINE_CONTINUE);
+
 	rm = vdev_raidz_map_alloc(zio, tvd->vdev_ashift, vd->vdev_children,
 	    vd->vdev_nparity);
 
